Scriptname CustomizableCamera extends SKI_ConfigBase

; OID
int v_idle_S
int h_idle_S
int v_combat_S
int h_combat_S
int zoom_combat_S
int vanity_max_S
int vanity_min_S
int wheel_speed_S
int wheel_increments_S
int pitch_zoom_S

; State
float v_idle = -10.0
float h_idle = 30.0
float v_combat = 20.0
float h_combat = 0.0
float zoom_combat = -100.0
float vanity_max = 600.0
float vanity_min = 155.0
float wheel_speed = 1.0
float wheel_increments = 0.1
float pitch_zoom = 100.0

event OnPageReset(string page)
SetCursorFillMode(TOP_TO_BOTTOM)
SetCursorPosition(0)
AddHeaderOption("Camera")
    h_idle_S = AddSliderOption("Horizontal ", h_idle, "{0}")
    v_idle_S = AddSliderOption("Vertical ", v_idle, "{0}")
    AddEmptyOption()
SetCursorPosition(1)
AddHeaderOption("Camera In Combat")
    h_combat_S = AddSliderOption("Horizontal ", h_combat, "{0}")
    v_combat_S = AddSliderOption("Vertical ", v_combat, "{0}")
    zoom_combat_S = AddSliderOption("Zoom ", zoom_combat, "{0}")

SetCursorPosition(8)
AddHeaderOption("Miscellaneous")
    vanity_min_S = AddSliderOption("Minimum Distance", vanity_min, "{0}")
    vanity_max_S = AddSliderOption("Maximum Distance", vanity_max, "{0}")
    AddEmptyOption()
    wheel_speed_S = AddSliderOption("Zoom Speed", wheel_speed, "{0}")
    wheel_increments_S = AddSliderOption("Zoom Increments", wheel_increments, "{1}")
    AddEmptyOption()
    pitch_zoom_S = AddSliderOption("Pitch Down Zoom", pitch_zoom, "{0}")
    
endEvent

event OnOptionSliderOpen(int option)
	if (option == v_idle_S)
		SetSliderDialogStartValue(v_idle)
		SetSliderDialogDefaultValue(-10.0)
		SetSliderDialogRange(-100.0, 100.0)
		SetSliderDialogInterval(1.0)

	elseIf (option == h_idle_S)
		SetSliderDialogStartValue(h_idle)
		SetSliderDialogDefaultValue(30.0)
		SetSliderDialogRange(-100.0, 100.0)
		SetSliderDialogInterval(1.0)
		
	elseIf (option == v_combat_S)
		SetSliderDialogStartValue(v_combat)
		SetSliderDialogDefaultValue(20.0)
		SetSliderDialogRange(-100.0, 100.0)
		SetSliderDialogInterval(1.0)
		
	elseIf (option == h_combat_S)
		SetSliderDialogStartValue(h_combat)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(-100.0, 100.0)
		SetSliderDialogInterval(1.0)
		
  elseIf (option == zoom_combat_S)
		SetSliderDialogStartValue(zoom_combat)
		SetSliderDialogDefaultValue(-100.0)
		SetSliderDialogRange(-300.0, 300.0)
		SetSliderDialogInterval(1.0)

  elseIf (option == vanity_max_S)
		SetSliderDialogStartValue(vanity_max)
		SetSliderDialogDefaultValue(600.0)
		SetSliderDialogRange(0.0, 1000.0)
		SetSliderDialogInterval(1.0)
		
  elseIf (option == vanity_min_S)
		SetSliderDialogStartValue(vanity_min)
		SetSliderDialogDefaultValue(155.0)
		SetSliderDialogRange(0.0, 1000.0)
		SetSliderDialogInterval(1.0)

  elseIf (option == wheel_speed_S)
		SetSliderDialogStartValue(wheel_speed)
		SetSliderDialogDefaultValue(1)
		SetSliderDialogRange(1.0, 20.0)
		SetSliderDialogInterval(1.0)
		
  elseIf (option == wheel_increments_S)
		SetSliderDialogStartValue(wheel_increments)
		SetSliderDialogDefaultValue(0.1)
		SetSliderDialogRange(0.1, 1.5)
		SetSliderDialogInterval(0.1)
		
  elseIf (option == pitch_zoom_S)
		SetSliderDialogStartValue(pitch_zoom)
		SetSliderDialogDefaultValue(100)
		SetSliderDialogRange(-500.0, 500.0)
		SetSliderDialogInterval(1.0)		

	endIf
endEvent

event OnOptionSliderAccept(int option, float value)
	if (option == v_idle_S)
		v_idle = value
		SetSliderOptionValue(v_idle_S, v_idle, "{0}")
		Utility.SetINIFloat("fOverShoulderPosZ:Camera", v_idle)
		Game.UpdateThirdPerson()
		
  elseIf (option == h_idle_S)
		h_idle = value
		SetSliderOptionValue(h_idle_S, h_idle, "{0}")
		Utility.SetINIFloat("fOverShoulderPosX:Camera", h_idle)
		Game.UpdateThirdPerson()
		
  elseIf (option == v_combat_S)
		v_combat = value
		SetSliderOptionValue(v_combat_S, v_combat, "{0}")
		Utility.SetINIFloat("fOverShoulderCombatPosZ:Camera", v_combat)
		Game.UpdateThirdPerson()
		
	elseIf (option ==h_combat_S)
		h_combat = value
		SetSliderOptionValue(h_combat_S, h_combat, "{0}")
		Utility.SetINIFloat("fOverShoulderCombatPosX:Camera", h_combat)
		Game.UpdateThirdPerson()
		
  elseIf (option == zoom_combat_S)
		zoom_combat = value
		SetSliderOptionValue(zoom_combat_S, zoom_combat, "{0}")
		Utility.SetINIFloat("fOverShoulderCombatAddY:Camera", zoom_combat)
		Game.UpdateThirdPerson()
		
  elseIf (option == vanity_max_S)
		vanity_max = value
		SetSliderOptionValue(vanity_max_S, vanity_max, "{0}")
		Utility.SetINIFloat("fVanityModeMaxDist:Camera", vanity_max)
		
  elseIf (option == vanity_min_S)
		vanity_min = value
		SetSliderOptionValue(vanity_min_S, vanity_min, "{0}")
		Utility.SetINIFloat("fVanityModeMinDist:Camera", vanity_min)
		
  elseIf (option == wheel_speed_S)
		wheel_speed = value
		SetSliderOptionValue(wheel_speed_S, wheel_speed, "{0}")
		Utility.SetINIFloat("fMouseWheelZoomSpeed:Camera", wheel_speed)
		
  elseIf (option == wheel_increments_S)
		wheel_increments = value
		SetSliderOptionValue(wheel_increments_S, wheel_increments, "{1}")
		Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", wheel_increments)
		
  elseIf (option == pitch_zoom_S)
		pitch_zoom = value
		SetSliderOptionValue(pitch_zoom_S, pitch_zoom, "{1}")
		Utility.SetINIFloat("fPitchZoomOutMaxDist:Camera", pitch_zoom)

	endIf
endEvent

event OnOptionHighlight(int option)
	if (option == v_idle_S)
		SetInfoText("The vertical distance from character while NOT in combat.\nDefault: -10")
	elseIf (option == h_idle_S)
		SetInfoText("The horizontal distance from character while NOT in combat.\nDefault: 30")
  elseIf (option == v_combat_S)
		SetInfoText("The vertical distance from character while IN combat.\nDefault: 20")
  elseIf (option == h_combat_S)
		SetInfoText("The horizontal distance from character while IN combat.\nDefault: 0")
	elseIf (option == zoom_combat_S)
		SetInfoText("The distance from character while IN combat.\n Positive values means zooming in. \nDefault: -100")
  elseIf (option == vanity_max_S)
		SetInfoText("Maximum distance from character.\nDefault: 600")
  elseIf (option == vanity_min_S)
		SetInfoText("Minimum distance from character.\nDefault: 155")
  elseIf (option == wheel_speed_S)
		SetInfoText("The speed of zoom.\nDefault: 1")
  elseIf (option == wheel_increments_S)
		SetInfoText("Affects he number of increments between MIN and MAX distance.\n Warning: Value doesnt mean quantity so try and see which value fits you. \n Default: 0.1")
  elseIf (option == pitch_zoom_S)
		SetInfoText("Looking down zooms in or out.\n Positive values means zooming out. \n Default: 100")
	endIf
endEvent

event OnConfigInit()
		Utility.SetINIFloat("fOverShoulderPosZ:Camera", v_idle)
		Utility.SetINIFloat("fOverShoulderPosX:Camera", h_idle)
		Utility.SetINIFloat("fOverShoulderCombatPosZ:Camera", v_combat)
		Utility.SetINIFloat("fOverShoulderCombatPosX:Camera", h_combat)
		Utility.SetINIFloat("fOverShoulderCombatAddY:Camera", zoom_combat)
		Utility.SetINIFloat("fVanityModeMaxDist:Camera", vanity_max)
		Utility.SetINIFloat("fVanityModeMinDist:Camera", vanity_min)
		Utility.SetINIFloat("fMouseWheelZoomSpeed:Camera", wheel_speed)
		Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", wheel_increments)
		Utility.SetINIFloat("fPitchZoomOutMaxDist:Camera", pitch_zoom)
endevent

event OnGameReload()
    parent.OnGameReload()
		Utility.SetINIFloat("fOverShoulderPosZ:Camera", v_idle)
		Utility.SetINIFloat("fOverShoulderPosX:Camera", h_idle)
		Utility.SetINIFloat("fOverShoulderCombatPosZ:Camera", v_combat)
		Utility.SetINIFloat("fOverShoulderCombatPosX:Camera", h_combat)
		Utility.SetINIFloat("fOverShoulderCombatAddY:Camera", zoom_combat)
		Utility.SetINIFloat("fVanityModeMaxDist:Camera", vanity_max)
		Utility.SetINIFloat("fVanityModeMinDist:Camera", vanity_min)
		Utility.SetINIFloat("fMouseWheelZoomSpeed:Camera", wheel_speed)
		Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", wheel_increments)
		Utility.SetINIFloat("fPitchZoomOutMaxDist:Camera", pitch_zoom)
endevent